/**
* Programa SueldoMedio.java
*
* Creado por: Mari Carmen Otero
* Fecha: Agosto 2002
*
**/

import java.io.*;

public class SueldoMedio
{
  public static void main(String[] args) throws IOException
  {
      //ficheros de entrada y de salida
      File           ficheroEntrada1  = new File("registroPersonal.txt");
      FileReader     leeFichero1      = new FileReader(ficheroEntrada1);
      BufferedReader lectorBuffer     = new BufferedReader(leeFichero1);

	  File               ficheroEntrada2     = new File("sueldosMes.datos");
      FileInputStream    flujoEntradaF2      = new FileInputStream(ficheroEntrada2);
      ObjectInputStream  flujoEntradaObjeto  = new ObjectInputStream(flujoEntradaF2);

      File              ficheroSalida1       = new File("sueldosHombre.txt");
      FileOutputStream  flujoSalidaF1        = new FileOutputStream(ficheroSalida1);
      PrintWriter       flujoSalida1         = new PrintWriter(flujoSalidaF1);

	  File              ficheroSalida2       = new File("sueldosMujer.txt");
      FileOutputStream  flujoSalidaF2        = new FileOutputStream(ficheroSalida2);
      PrintWriter       flujoSalida2         = new PrintWriter(flujoSalidaF2);

      //Fichero de entrada 'sueldosMes.datos'
	  //
	  //Cargar el archivo anterior en un array de objetos Sueldo
	  Sueldo objetoSueldo;

	  Sueldo [] arraySueldos = new Sueldo [7];

	  int i = 0;
	  boolean eof = false;

      while(!eof)
      {
           try
           {
              objetoSueldo = (Sueldo) flujoEntradaObjeto.readObject();
              arraySueldos [i] = objetoSueldo;
              i++;
           }
           catch(EOFException e)
           {
               eof = true;
           }
           catch (ClassNotFoundException e)
           {
			   eof = true;
	       }
      }

      flujoEntradaObjeto.close();

      //variables relacionadas con los atributos
      //del fichero 'registroPersonal.txt'
      String apeNom, sexoSituacion, codCategoria;
      float sueldosTotHombre = 0.0f, sueldosTotMujer = 0.0f;
      int numH = 0, numM = 0;

      //Fichero de Entrada 'registroPersonal.txt'
      //
      //leer el String correspondiente al nombre del empleado
      apeNom = lectorBuffer.readLine();

      while(apeNom != null)
      {
          sexoSituacion = lectorBuffer.readLine();
          char sexo = sexoSituacion.charAt(0);
          char situacion = sexoSituacion.charAt(1);

          codCategoria = lectorBuffer.readLine();
          int cod = Integer.parseInt(codCategoria);

		  if ( situacion == 'A' )
		  {
			  i = 0;
			  while ( arraySueldos[i].obtenerCodigo() != cod &&
					  i < 7)
			  {
				i++;
				//System.out.println("Valor de i: " + i);
			  }

			  float sueldoCat = arraySueldos[i].obtenerEuros();

			  if ( sexo == 'V' )
			  {
				  sueldosTotHombre = sueldosTotHombre + sueldoCat;
			  	  numH = numH + 1;
			  	  flujoSalida1.println(apeNom + "\t " + sueldoCat + " euros");
			  }
			  else
			  {
			      sueldosTotMujer = sueldosTotMujer + sueldoCat;
			      numM = numM + 1;
			  	  flujoSalida2.println(apeNom + "\t " + sueldoCat + " euros");
		  	  }
          }

	  	  apeNom = lectorBuffer.readLine();
      }

      flujoSalida1.println();
      flujoSalida2.println();
      flujoSalida1.println("SUELDO MEDIO: \t \t " + sueldosTotHombre / numH + " euros");
      flujoSalida2.println("SUELDO MEDIO: \t \t " + sueldosTotMujer / numM + " euros");

      System.out.println("Fin - ficheros obtenidos * sueldosHombre.txt * y * sueldosMujer.txt *");

      //cerrar los ficheros
      lectorBuffer.close();
      flujoSalida1.close();
      flujoSalida2.close();
  }
}

